# -*- coding: utf-8 -*-
"""
Created on Mon Aug  8 15:04:12 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from builtins import object
class sort(object):
    register = {}

    def __init__(self,  name=None):
        self.name = name
        sort.register[name] = self
        return
        
    """
    check if a sort name already exists in the register
    """
    @staticmethod
    def checkSort(name):
        if name not in sort.register:
            return False
        else:
            return True
            
    def registerSort(self, name):
        sort.register[name] = self
        
    @staticmethod
    def getSort(name):
        try:
            return sort.register[name]
        except:
            return None            
        
    @staticmethod
    def cleanup():
        for i in list(sort.register.keys()):
            del sort.register[i]
            
    def __str__(self):
        return str(self.name)
            
    """
    checking if two sorts are the same
    the two sorts are the same if they have the same name and same description
    """
    def __eq__(self, other):
        if self is other:
            return True
        if other is None or not isinstance(other, sort):
            return False
        return (self.name == other.name) and (self.description == other.description)
        
    def __ne__(self, other):
        return not self == other
 
    
    """
    """
    def compareValue(self, other):
        if self.name == other.name:
            if str(self.__dict__) > str(other.__dict__):
                return 1
            elif str(self.__dict__) < str(other.__dict__):
                return -1
            else: 
                return 0
        elif self.name > other.name:
            return 1
        else: 
            return -1

    """
    getting the base sort of the sort
    most sorts (primitive sort and disjunctive sort) have itself as the base sort,
    however attribute sorts have a different base sort.
    this function will only be called by primitive sorts and disjunctive sorts
    """
    def baseSort(self):
        return self

    """
    less than
    """
    def __lt__(self, other):
        if self.name < other.name:
            return True
        if str(self.__dict__) < str(other.__dict__):
            return True
        return False
        
    """
    less than or equal to
    """
    def __le__(self, other):
        if self.name <= other.name:
            return True
        if str(self.__dict__) <= str(other.__dict__):
            return True
        return False
        
    """
    greater than
    """
    def __gt__(self, other):
        if self.name > other.name:
            return True
        if str(self.__dict__) > str(other.__dict__):
            return True
        return False
        
    """
    greater than or equal to
    """
    def __ge__(self, other):
        if self.name >= other.name:
            return True
        if str(self.__dict__) >= str(other.__dict__):
            return True
        return False    
        
    """
    creating a form of the sort
    """
    def newForm(self):
        raise NotImplementedError 
        
'''
to be implemented...

def assign(self)
def names(self)
def components(self)
def setStats(self)
name()
'''