# -*- coding: utf-8 -*-
"""
Created on Mon Oct 10 16:39:28 2016

@author: akibdpt
"""


from sortal import (rule, primitiveSort, lineSegment2D, vector2D)
from api.api_create import create # Imports create methods to use create.polygon_form to make LHS and RHS in rules
from api.sort_types import sort_types # Imports sort types

create = create() 
    
def rule3a():
    v1 = vector2D (0, 0) 
    v2 = vector2D (0, 1) 
    v3 = vector2D (1, 1)
    v4 = vector2D (1, 2)
    v5 = vector2D (2, 2) 
    v6 = vector2D (2, 0)
    
    v7 = vector2D (1, -1)
    v8 = vector2D (1, 0)
    v9 = vector2D (2, 0) 
    v10 = vector2D (2, 1)
    v11 = vector2D (3, 1)
    v12 = vector2D (3, -1)

    # LHS
    formL1_set = [v1, v2, v3, v4, v5, v6]
    formL1 = create.polygonForm(sort_types['lineSeg2D'], formL1_set)
    
    # RHS
    formL2_set = [v7, v8, v9, v10, v11, v12]
    formL2 = create.polygonForm(sort_types['lineSeg2D'], formL2_set)
    
    r = rule('Rule 2', 'Moves L-shaped polygons diagonally upwards or downwards', formL1, formL2)
    return r
    
def rule3b():
    v1 = vector2D (0, 0) 
    v2 = vector2D (0, 2) 
    v3 = vector2D (2, 2)
    v4 = vector2D (2, 0)
    
    v5 = vector2D (-1, -1)
    v6 = vector2D (-1, 1)
    v7 = vector2D (1, 1) 
    v8 = vector2D (1, -1)
    
    # LHS
    formL1_set = [v1, v2, v3, v4]
    formL1 = create.polygonForm(sort_types['lineSeg2D'], formL1_set)
    
    # RHS
    formL2_set = [v5, v6, v7, v8]
    formL2 = create.polygonForm(sort_types['lineSeg2D'], formL2_set)
    
    r = rule('Rule 3', 'Moves squares diagonally upwards or downwards', formL1, formL2)
    return r