# -*- coding: utf-8 -*-
"""
Created on Tue May 30 10:21:21 2017

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str

from .rule import rule

"""
flow: a set of rules that are to be performed in a certain order
"""
class flow(rule):
    
    type = 'rule-flow'
    
    def __init__(self, name, description, rules, *args, **kwargs):
        self.rules = rules
        self.process = None
        
    def __str__(self):
        return str(self.rules)
    
    def detect(self, *args, **kwargs):
        raise NotImplementedError

    def apply(self, form, printProcess = False, random = True, *args, **kwargs):
        self.process = []
        form = self.rules.apply(form, s = self.process, random = random)
        print('\n\ncomplete flow:\n<Begin>', end='')
        for i in self.process:
            print(i,end='')
        print(' <end>')
        return form
        #raise NotImplementedError

