from rhino_specific.rhino_specific_attributes import rhino_methods as rm
import rhinoscriptsyntax as rs

"""
INSTRUCTIONS

To use any of the functions to handle attributes in the drawing, 
remove the comment decorator from the line.
"""

# Adds label to Rhino objects
rm.addLabel()

# Adds line width (weight) to lines or grayscale color (weight255) to text dots and points (but for points, it is not very visible)
rm.addWeight()

# Removes label from Rhino objects
#rm.delLabel()

# Attaches a text dot to a line
#rm.attachLabel()

# Adds description to a Rhino object's user text
#rm.addDesc()

# Adds enumerative value to a Rhino object's user text
#rm.addEnum()

# Adds color to a Rhino object; color is not visible in Print Preview
#rm.addColor()

 