# -*- coding: utf-8 -*-
"""
Created on Fri Aug  5 11:38:03 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
"""
from future import standard_library
standard_library.install_aliases()
"""
#from builtins import object
class element(object):
    """
    initializing the element
    an element (individual or form) needs to belong to a sort
    an element can also be associated with another element: the element belongs
    to a form or the element is a codescriptor of another element
    """
    def __init__(self, sort):
        self.assoc = None
        self.sort = sort
        
    def __repr__(self):
        return str(self)

    """
    check equality
    """
    def __eq__(self, other):
        if other is None or other.__class__ != self.__class__ or not other.sort == self.sort:
            return False
        return self.equals(other)
        
    """
    check equality
    """
    def __ne__(self, other):
        return not self == other
    
    """
    less than
    """
    def __lt__(self, other):
        if self.compareValue(other) == -1:
            return True
        return False
    """
    less than or equals to
    """
    def __le__(self, other):
        if self.compareValue(other) < 1 :
            return True
        return False
    """
    greater than
    """
    def __gt__(self, other):
        if self.compareValue(other) == 1:
            return True
        return False
    """
    greater than or equals to
    """
    def __ge__(self, other):
        if self.compareValue(other) > -1:
            return True
        return False
        
    def accept(self):
        raise NotImplementedError 
        
    def compareValue(self):
        raise NotImplementedError 
                
    def edit(self, editor):
        raise NotImplementedError
    
    """
    transforming the element, essentially editing the element with the transform
    set as editor
    """
    def transform(self, tfSet):
        return self.edit(tfSet)
        
    """
    duplicating the element
    """
    def duplicate(self):
        if 'ind' in self.type:
            return self.duplicateInd()
        else:
            return self.duplicateForm()
                
    #------------------------------------------------------------
"""    
    def hashcode(self):
        return
    def clear(self):
        return 
    def parse(self):
        return 
    def parse(self):
        return 
    def convert(self):
        return 
    def transform(self):
        return   
""" 